Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxextension.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
@@ -980,77 +885,392 @@ static void dmxBECreateWindowTree(int id
     }
 }
 
-/* Refresh screen by generating exposure events for all windows */
-static void dmxForceExposures(int idx)
+static void dmxBEMapRootWindow(int idx)
 {
-    ScreenPtr      pScreen   = screenInfo.screens[idx];
-    WindowPtr  pRoot     = WindowTable[idx];
-    Bool       anyMarked = FALSE;
-    WindowPtr  pChild;
+    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
 
-    for (pChild = pRoot->firstChild; pChild; pChild = pChild->nextSib)
-	anyMarked |= pScreen->MarkOverlappedWindows(pChild, pChild,
-						    (WindowPtr *)NULL);
-    if (anyMarked) {
-	/* If any windows have been marked, set the root window's
-	 * clipList to be broken since it will be recalculated in
-	 * ValidateTree()
-	 */
-	REGION_BREAK(pScreen, &pRoot->clipList);
-	pScreen->ValidateTree(pRoot, NULL, VTBroken);
-	pScreen->HandleExposures(pRoot);
-	if (pScreen->PostValidateTree)
-	    pScreen->PostValidateTree(pRoot, NULL, VTBroken);
+    XLIB_PROLOGUE (dmxScreen);
+    XMapWindow(dmxScreen->beDisplay, dmxScreen->rootWin);
+    XLIB_EPILOGUE (dmxScreen);
+}
+
+static void dmxBECreateWindowProperties (int idx)
+{
+    WindowPtr      pRoot  = WindowTable[idx];
+    WindowPtr      pRoot0 = pRoot;
+    WindowPtr      pWin;
+    WindowPtr      pWin0;
+    PropertyPtr    pProp, pLast;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+	pRoot0 = WindowTable[0];
+#endif
+
+    pWin = pRoot;
+    pWin0 = pRoot0;
+    while (pWin)
+    {
+	pLast = NULL;
+	do
+	{
+	    for (pProp = wUserProps (pWin0); pProp; pProp = pProp->next)
+	    	if (pProp->next == pLast)
+		    break;
+
+	    if (pProp)
+		dmxBESetWindowProperty (pWin, (pLast = pProp));
+	} while (pLast != wUserProps (pWin0));
+
+	/* Next, create the bottom-most child */
+	if (pWin->lastChild) {
+	    pWin = pWin->lastChild;
+	    pWin0 = pWin0->lastChild;
+	    continue;
+	}
+
+	/* If the window has no children, move on to the next higher window */
+	while (!pWin->prevSib && (pWin != pRoot))
+	{
+	    pWin = pWin->parent;
+	    pWin0 = pWin0->parent;
+	}
+
+	if (pWin->prevSib) {
+	    pWin = pWin->prevSib;
+	    pWin0 = pWin0->prevSib;
+	    continue;
+	}
+
+	/* When we reach the root window, we are finished */
+	if (pWin == pRoot)
+	    break;
     }
 }
 
 /** Compare the new and old screens to see if they are compatible. */
-static Bool dmxCompareScreens(DMXScreenInfo *new, DMXScreenInfo *old)
+static Bool dmxCompareScreens(DMXScreenInfo      *new,
+			      DMXScreenInfo      *old,
+			      dmxErrorSetProcPtr errorSet,
+			      void		 *error,
+			      const char         *errorName)
 {
     int i;
 
-    if (new->beWidth != old->beWidth) return FALSE;
-    if (new->beHeight != old->beHeight) return FALSE;
-    if (new->beDepth != old->beDepth) return FALSE;
-    if (new->beBPP != old->beBPP) return FALSE;
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	ScreenPtr pScreen = screenInfo.screens[0];
+	int       j;
+
+	old = dmxScreens; /* each new screen must match the first screen */
+
+	if (new->beDepth != old->beDepth)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "Screen depth is not %d",
+			    old->beDepth);
+	    return FALSE;
+	}
+
+	if (new->beBPP != old->beBPP)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "Screen BPP is not %d",
+			    old->beBPP);
+	    return FALSE;
+	}
+
+	for (i = 0; i < old->beNumDepths; i++)
+	{
+	    for (j = 0; j < new->beNumDepths; j++)
+		if (new->beDepths[j] == old->beDepths[i])
+		    break;
+
+	    if (j == new->beNumDepths)
+	    {
+		dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+				"Screen doesn't support depth %d",
+				old->beDepths[i]);
+		return FALSE;
+	    }
+	}
+
+	for (i = 0; i < old->beNumPixmapFormats; i++)
+	{
+	    for (j = 0; j < new->beNumPixmapFormats; j++)
+		if (new->bePixmapFormats[j].depth ==
+		    old->bePixmapFormats[i].depth &&
+		    new->bePixmapFormats[j].bits_per_pixel ==
+		    old->bePixmapFormats[i].bits_per_pixel &&
+		    new->bePixmapFormats[j].scanline_pad ==
+		    old->bePixmapFormats[i].scanline_pad)
+		    break;
+
+	    if (j == new->beNumPixmapFormats)
+	    {
+		dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+				"Screen doesn't support pixmap format "
+				"depth=%d,bits_per_pixel=%d,scanline_pad=%d\n",
+				old->bePixmapFormats[i].depth,
+				old->bePixmapFormats[i].bits_per_pixel,
+				old->bePixmapFormats[i].scanline_pad);
+		return FALSE;
+	    }
+	}
+
+	for (i = 0; i < pScreen->numVisuals; i++)
+	{
+	    int k;
+
+	    for (k = 0; k < old->beNumVisuals; k++)
+		if (pScreen->visuals[i].class ==
+		    old->beVisuals[k].class &&
+		    pScreen->visuals[i].bitsPerRGBValue ==
+		    old->beVisuals[k].bits_per_rgb &&
+		    pScreen->visuals[i].ColormapEntries ==
+		    old->beVisuals[k].colormap_size &&
+		    pScreen->visuals[i].nplanes ==
+		    old->beVisuals[k].depth &&
+		    pScreen->visuals[i].redMask ==
+		    old->beVisuals[k].red_mask &&
+		    pScreen->visuals[i].greenMask ==
+		    old->beVisuals[k].green_mask &&
+		    pScreen->visuals[i].blueMask ==
+		    old->beVisuals[k].blue_mask)
+		    break;
+
+	    assert (k < old->beNumVisuals);
+
+	    for (j = 0; j < new->beNumVisuals; j++)
+		if (new->beVisuals[j].depth ==
+		    old->beVisuals[k].depth &&
+		    new->beVisuals[j].class ==
+		    old->beVisuals[k].class &&
+		    new->beVisuals[j].red_mask ==
+		    old->beVisuals[k].red_mask &&
+		    new->beVisuals[j].green_mask ==
+		    old->beVisuals[k].green_mask &&
+		    new->beVisuals[j].blue_mask ==
+		    old->beVisuals[k].blue_mask &&
+		    new->beVisuals[j].bits_per_rgb >=
+		    old->beVisuals[k].bits_per_rgb &&
+		    new->beVisuals[j].colormap_size >=
+		    old->beVisuals[k].colormap_size)
+		    break;
+
+	    if (j == new->beNumVisuals)
+	    {
+		dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+				"Screen doesn't support visual: "
+				"class: %s, "
+				"depth: %d planes, "
+				"available colormap entries: %d%s, "
+				"red/green/blue masks: 0x%lx/0x%lx/0x%lx, "
+				"significant bits in color specification: "
+				"%d bits",
+				old->beVisuals[k].class == StaticGray ?
+				"StaticGray" :
+				old->beVisuals[k].class == GrayScale ?
+				"GrayScale" :
+				old->beVisuals[k].class == StaticColor ?
+				"StaticColor" :
+				old->beVisuals[k].class == PseudoColor ?
+				"PseudoColor" :
+				old->beVisuals[k].class == TrueColor ?
+				"TrueColor" :
+				old->beVisuals[k].class == DirectColor ?
+				"DirectColor" :
+				"Unknown Class",
+				old->beVisuals[k].depth,
+				old->beVisuals[k].colormap_size,
+				(old->beVisuals[k].class == TrueColor ||
+				 old->beVisuals[k].class == DirectColor) ?
+				" per subfield" : "",
+				old->beVisuals[k].red_mask,
+				old->beVisuals[k].green_mask,
+				old->beVisuals[k].blue_mask,
+				old->beVisuals[k].bits_per_rgb);
+		return FALSE;
+	    }
+	}
+
+	return TRUE;
+    }
+#endif
+
+    if (new->beWidth != old->beWidth || new->beHeight != old->beHeight)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen dimensions are not %dx%d",
+			old->beWidth, old->beHeight);
+	return FALSE;
+    }
+    if (new->beDepth != old->beDepth)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen depth is not %d",
+			old->beDepth);
+	return FALSE;
+    }
+    if (new->beBPP != old->beBPP)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen BPP is not %dx%d",
+			old->beBPP);
+	return FALSE;
+    }
+    if (new->beNumDepths != old->beNumDepths)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen number of depths is not %d",
+			old->beNumDepths);
+	return FALSE;
+    }
 
-    if (new->beNumDepths != old->beNumDepths) return FALSE;
     for (i = 0; i < old->beNumDepths; i++)
-	if (new->beDepths[i] != old->beDepths[i]) return FALSE;
+	if (new->beDepths[i] != old->beDepths[i])
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "Screen depth index %d is not %d",
+			    i, old->beDepths[i]);
+	    return FALSE;
+	}
 
-    if (new->beNumPixmapFormats != old->beNumPixmapFormats) return FALSE;
+    if (new->beNumPixmapFormats != old->beNumPixmapFormats)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen number of pixmap formats is not %d",
+			old->beNumPixmapFormats);
+	return FALSE;
+    }
     for (i = 0; i < old->beNumPixmapFormats; i++) {
 	if (new->bePixmapFormats[i].depth !=
-	    old->bePixmapFormats[i].depth) return FALSE;
+	    old->bePixmapFormats[i].depth)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "depth of screen pixmap format index %d is not %d",
+			    i, old->bePixmapFormats[i].depth);
+	    return FALSE;
+	}
 	if (new->bePixmapFormats[i].bits_per_pixel !=
-	    old->bePixmapFormats[i].bits_per_pixel) return FALSE;
+	    old->bePixmapFormats[i].bits_per_pixel)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "bits_per_pixel of screen pixmap format "
+			    "index %d is not %d",
+			    i, old->bePixmapFormats[i].bits_per_pixel);
+	    return FALSE;
+	}
 	if (new->bePixmapFormats[i].scanline_pad !=
-	    old->bePixmapFormats[i].scanline_pad) return FALSE;
+	    old->bePixmapFormats[i].scanline_pad)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "scanline_pad of screen pixmap format "
+			    "index %d is not %d",
+			    i, old->bePixmapFormats[i].scanline_pad);
+	    return FALSE;
+	}
     }
 
-    if (new->beNumVisuals != old->beNumVisuals) return FALSE;
+    if (new->beNumVisuals != old->beNumVisuals)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen number of visuals is not %d",
+			old->beNumVisuals);
+	return FALSE;
+    }
     for (i = 0; i < old->beNumVisuals; i++) {
 	if (new->beVisuals[i].visualid !=
-	    old->beVisuals[i].visualid) return FALSE;
+	    old->beVisuals[i].visualid)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "visualid of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].visualid);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].screen !=
-	    old->beVisuals[i].screen) return FALSE;
+	    old->beVisuals[i].screen)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "screen of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].screen);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].depth !=
-	    old->beVisuals[i].depth) return FALSE;
+	    old->beVisuals[i].depth)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "depth of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].depth);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].class !=
-	    old->beVisuals[i].class) return FALSE;
+	    old->beVisuals[i].class)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "class of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].class);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].red_mask !=
-	    old->beVisuals[i].red_mask) return FALSE;
+	    old->beVisuals[i].red_mask)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "red_mask of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].red_mask);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].green_mask !=
-	    old->beVisuals[i].green_mask) return FALSE;
+	    old->beVisuals[i].green_mask)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "green_mask of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].green_mask);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].blue_mask !=
-	    old->beVisuals[i].blue_mask) return FALSE;
+	    old->beVisuals[i].blue_mask)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "blue_mask of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].blue_mask);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].colormap_size !=
-	    old->beVisuals[i].colormap_size) return FALSE;
+	    old->beVisuals[i].colormap_size)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "colormap_size of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].colormap_size);
+	    return FALSE;
+	}
 	if (new->beVisuals[i].bits_per_rgb !=
-	    old->beVisuals[i].bits_per_rgb) return FALSE;
+	    old->beVisuals[i].bits_per_rgb)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "bits_per_rgb of screen visual "
+			    "index %d is not %d",
+			    i, old->beVisuals[i].bits_per_rgb);
+	    return FALSE;
+	}
     }
 
-    if (new->beDefVisualIndex != old->beDefVisualIndex) return FALSE;
+    if (new->beDefVisualIndex != old->beDefVisualIndex)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Screen default visual index is not %d",
+			old->beDefVisualIndex);
+	return FALSE;
+    }
 
     return TRUE;
 }
@@ -1063,20 +1283,23 @@ static void dmxBERestoreRenderPict(point
     DrawablePtr  pDraw    = pPicture->pDrawable; /* The picture's drawable */
     int          scrnNum  = (int)n;
 
-    if (pDraw->pScreen->myNum != scrnNum) {
-	/* Picture not on the screen we are restoring*/
-	return;
-    }
+    if (pDraw)
+    {
+	if (pDraw->pScreen->myNum != scrnNum) {
+	    /* Picture not on the screen we are restoring*/
+	    return;
+	}
 
-    if (pDraw->type == DRAWABLE_PIXMAP) {
-	PixmapPtr  pPixmap = (PixmapPtr)pDraw;
+	if (pDraw->type == DRAWABLE_PIXMAP) {
+	    PixmapPtr  pPixmap = (PixmapPtr)pDraw;
 	
-	/* Create and restore the pixmap drawable */
-	dmxBECreatePixmap(pPixmap);
-	dmxBERestorePixmap(pPixmap);
+	    /* Create and restore the pixmap drawable */
+	    dmxBECreatePixmap(pPixmap);
+	    dmxBERestorePixmap(pPixmap);
+	}
     }
 
-    dmxBECreatePicture(pPicture);
+    dmxBECreatePicture(scrnNum, pPicture);
 }
 
 /** Restore Render's glyphs */
@@ -1093,7 +1316,7 @@ static void dmxBERestoreRenderGlyph(poin
     char            *pos;
     int              beret;
     int              len_images = 0;
-    int              i;
+    int              i, size;
     int              ctr;
 
     if (glyphPriv->glyphSets[scrnNum]) {
@@ -1117,9 +1340,18 @@ static void dmxBERestoreRenderGlyph(poin
 	GlyphPtr     gl = gr->glyph;
 
 	if (!gl || gl == DeletedGlyph) continue;
-	len_images += gl->size - sizeof(gl->info);
+
+	size = gl->info.height * PixmapBytePad (gl->info.width,
+						glyphSet->format->depth);
+	if (size & 3)
+	    size += 4 - (size & 3);
+
+	len_images += size;
     }
 
+    if (!len_images)
+	return;
+
     /* Now allocate the memory we need */
     images = xalloc(len_images*sizeof(char));
     gids   = xalloc(glyphSet->hash.tableEntries*sizeof(Glyph));
@@ -1133,6 +1365,7 @@ static void dmxBERestoreRenderGlyph(poin
     for (i = 0; i < glyphSet->hash.hashSet->size; i++) {
 	GlyphRefPtr  gr = &table[i];
 	GlyphPtr     gl = gr->glyph;
+	char         *data;
 
 	if (!gl || gl == DeletedGlyph) continue;
 
@@ -1147,32 +1380,63 @@ static void dmxBERestoreRenderGlyph(poin
 	glyphs[ctr].xOff   = gl->info.xOff;
 	glyphs[ctr].yOff   = gl->info.yOff;
 
-	/* Copy the images from the DIX's data into the buffer */
-	memcpy(pos, gl+1, gl->size - sizeof(gl->info));
-	pos += gl->size - sizeof(gl->info);
+	size = gl->info.height * PixmapBytePad (gl->info.width,
+						glyphSet->format->depth);
+	if (size & 3)
+	    size += 4 - (size & 3);
+
+	data = dixLookupPrivate (&(gl)->devPrivates, dmxGlyphPrivateKey);
+	if (data)
+	{
+	    memcpy (pos, data, size);
+	}
+	else
+	{
+	    dmxLog (dmxWarning,
+		    "Cannot restore glyph image: %dx%d %d\n",
+		    gl->info.width,
+		    gl->info.height,
+		    glyphSet->format->depth);
+
+	    memset (pos, 0xff, size);
+	}
+
+	pos += size;
 	ctr++;
     }
-    
+
     /* Now restore the glyph data */
+    XLIB_PROLOGUE (dmxScreen);
     XRenderAddGlyphs(dmxScreen->beDisplay, glyphPriv->glyphSets[scrnNum],
-		     gids,glyphs, glyphSet->hash.tableEntries, images,
-		     len_images);
+		     gids, glyphs, ctr, images, len_images);
+    XLIB_EPILOGUE (dmxScreen);
 
     /* Clean up */
-    xfree(len_images);
+    xfree(images);
     xfree(gids);
     xfree(glyphs);    
 }
 #endif
 
 /** Reattach previously detached back-end screen. */
-int dmxAttachScreen(int idx, DMXScreenAttributesPtr attr)
+int
+dmxAttachScreen (int                    idx,
+		 DMXScreenAttributesPtr attr,
+		 unsigned int		window,
+		 const char             *authType,
+		 int                    authTypeLen,
+		 const char             *authData,
+		 int                    authDataLen,
+		 dmxErrorSetProcPtr     errorSet,
+		 void			*error,
+		 const char             *errorName)
 {
-    ScreenPtr      pScreen;
+    ScreenPtr     pScreen;
     DMXScreenInfo *dmxScreen;
-    CARD32         scrnNum   = idx;
-    DMXScreenInfo  oldDMXScreen;
-    int            i;
+    DMXScreenInfo oldDMXScreen;
+    Bool          beShape = FALSE;
+    Bool          beRender = FALSE;
+    int           errorBase, eventBase;
 
     /* Return failure if dynamic addition/removal of screens is disabled */
     if (!dmxAddRemoveScreens) {
@@ -1184,19 +1448,28 @@ int dmxAttachScreen(int idx, DMXScreenAt
 	       "add the \"-addremovescreens\" option either to the command\n");
 	dmxLog(dmxWarning,
 	       "line or in the configuration file.\n");
+	dmxErrorSet (errorSet, error, errorName,
+		     "Screen attach extension has not been enabled");
 	return 1;
     }
 
     /* Cannot add a screen that does not exist */
-    if (idx < 0 || idx >= dmxNumScreens) return 1;
+    if (idx < 0 || idx >= dmxNumScreens)
+    {
+	dmxErrorSet (errorSet, error, errorName,
+		     "Screen %d does not exist", idx);
+	return 1;
+    }
+
     pScreen = screenInfo.screens[idx];
     dmxScreen = &dmxScreens[idx];
 
     /* Cannot attach to a screen that is already opened */
-    if (dmxScreen->beDisplay) {
-	dmxLog(dmxWarning,
-	       "Attempting to add screen #%d but a screen already exists\n",
-	       idx);
+    if (dmxScreen->name && *dmxScreen->name) {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Attempting to attach back-end server to screen #%d "
+			"but back-end server is already attached to this "
+			"screen", idx);
 	return 1;
     }
 
@@ -1205,28 +1478,100 @@ int dmxAttachScreen(int idx, DMXScreenAt
     /* Save old info */
     oldDMXScreen = *dmxScreen;
 
-    /* Copy the name to the new screen */
-    dmxScreen->name = strdup(attr->displayName);
+    dmxScreen->scrnWin   = window;
+    dmxScreen->virtualFb = FALSE;
 
     /* Open display and get all of the screen info */
-    if (!dmxOpenDisplay(dmxScreen)) {
-	dmxLog(dmxWarning,
-               "dmxOpenDisplay: Unable to open display %s\n",
-               dmxScreen->name);
+    if (!dmxOpenDisplay(dmxScreen,
+			attr->displayName,
+			authType,
+			authTypeLen,
+			authData,
+			authDataLen)) {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"Can't open display: %s",
+			attr->displayName);
 
 	/* Restore the old screen */
 	*dmxScreen = oldDMXScreen;
 	return 1;
     }
 
+    XLIB_PROLOGUE (dmxScreen);
+    beShape = XShapeQueryExtension (dmxScreen->beDisplay,
+				    &dmxScreen->beShapeEventBase,
+				    &errorBase);
+    XLIB_EPILOGUE (dmxScreen);
+
+    if (!beShape)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"SHAPE extension missing on back-end server");
+	dmxCloseDisplay (dmxScreen);
+
+	/* Restore the old screen */
+	*dmxScreen = oldDMXScreen;
+	return 1;
+    }
+
+    XLIB_PROLOGUE (dmxScreen);
+    beRender = XRenderQueryExtension (dmxScreen->beDisplay,
+				      &eventBase,
+				      &errorBase);
+    XLIB_EPILOGUE (dmxScreen);
+
+    if (!beRender)
+    {
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"RENDER extension missing on back-end server");
+	dmxCloseDisplay (dmxScreen);
+
+	/* Restore the old screen */
+	*dmxScreen = oldDMXScreen;
+	return 1;
+    }
+
+#ifdef COMPOSITE
+    if (!noCompositeExtension)
+    {
+	Bool beComposite = FALSE;
+
+	XLIB_PROLOGUE (dmxScreen);
+	beComposite = XCompositeQueryExtension (dmxScreen->beDisplay,
+						&eventBase,
+						&errorBase);
+	XLIB_EPILOGUE (dmxScreen);
+
+	if (!beComposite)
+	{
+	    dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			    "Composite extension missing on back-end server");
+	    dmxCloseDisplay (dmxScreen);
+
+	    /* Restore the old screen */
+	    *dmxScreen = oldDMXScreen;
+	    return 1;
+	}
+    }
+#endif
+
+    if (!dmxScreen->scrnWin)
+	dmxScreen->scrnWin = DefaultRootWindow (dmxScreen->beDisplay);
+
+    XLIB_PROLOGUE (dmxScreen);
+    XSelectInput (dmxScreen->beDisplay,
+		  dmxScreen->scrnWin,
+		  StructureNotifyMask);
+    XLIB_EPILOGUE (dmxScreen);
+
     dmxSetErrorHandler(dmxScreen);
-    dmxCheckForWM(dmxScreen);
     dmxGetScreenAttribs(dmxScreen);
 
     if (!dmxGetVisualInfo(dmxScreen)) {
-	dmxLog(dmxWarning, "dmxGetVisualInfo: No matching visuals found\n");
+	dmxLogErrorSet (dmxWarning, errorSet, error, errorName,
+			"No matching visuals found");
 	XFree(dmxScreen->beVisuals);
-	XCloseDisplay(dmxScreen->beDisplay);
+	dmxCloseDisplay (dmxScreen);
 
 	/* Restore the old screen */
 	*dmxScreen = oldDMXScreen;
@@ -1238,28 +1583,85 @@ int dmxAttachScreen(int idx, DMXScreenAt
 
     /* Verify that the screen to be added has the same info as the
      * previously added screen. */
-    if (!dmxCompareScreens(dmxScreen, &oldDMXScreen)) {
+    if (!dmxCompareScreens(dmxScreen,
+			   &oldDMXScreen,
+			   errorSet,
+			   error,
+			   errorName))
+    {
 	dmxLog(dmxWarning,
 	       "New screen data (%s) does not match previously\n",
 	       dmxScreen->name);
 	dmxLog(dmxWarning,
-	       "attached screen data (%s)\n",
-	       oldDMXScreen.name);
+	       "attached screen data\n");
 	dmxLog(dmxWarning,
 	       "All data must match in order to attach to screen #%d\n",
 	       idx);
 	XFree(dmxScreen->beVisuals);
 	XFree(dmxScreen->beDepths);
 	XFree(dmxScreen->bePixmapFormats);
-	XCloseDisplay(dmxScreen->beDisplay);
+	dmxCloseDisplay (dmxScreen);
 
 	/* Restore the old screen */
 	*dmxScreen = oldDMXScreen;
 	return 1;
     }
 
+    /* Create the default font */
+    if (!dmxBELoadFont(pScreen, defaultFont))
+    {
+	dmxErrorSet (errorSet, error, errorName,
+		     "Failed to load default font");
+	XFree(dmxScreen->beVisuals);
+	XFree(dmxScreen->beDepths);
+	XFree(dmxScreen->bePixmapFormats);
+	dmxCloseDisplay (dmxScreen);
+
+	/* Restore the old screen */
+	*dmxScreen = oldDMXScreen;
+	return 1;
+    }
+
+    /* We used these to compare the old and new screens.  They are no
+     * longer needed since we have a newly attached screen, so we can
+     * now free the old screen's resources. */
+    if (oldDMXScreen.beVisuals)
+	XFree(oldDMXScreen.beVisuals);
+    if (oldDMXScreen.beDepths)
+	XFree(oldDMXScreen.beDepths);
+    if (oldDMXScreen.bePixmapFormats)
+	XFree(oldDMXScreen.bePixmapFormats);
+
+    if (attr->name)
+	dmxScreen->name = strdup(attr->name);
+    else
+	dmxScreen->name = strdup(attr->displayName);
+
+    dmxScreen->beAttachedDisplay = dmxScreen->beDisplay;
+    dmxScreen->beDisplay = NULL;
+
+    dmxScreen->rootX = attr->rootWindowXoffset;
+    dmxScreen->rootY = attr->rootWindowYoffset;
+
+    return 0; /* Success */
+}
+
+void
+dmxEnableScreen (int idx)
+{
+    ScreenPtr     pScreen;
+    DMXScreenInfo *dmxScreen;
+    int           i;
+
+    pScreen = screenInfo.screens[idx];
+    dmxScreen = &dmxScreens[idx];
+
+    dmxLogOutput(dmxScreen, "Enable screen #%d\n", idx);
+
+    dmxScreen->beDisplay = dmxScreen->beAttachedDisplay;
+
     /* Initialize the BE screen resources */
-    dmxBEScreenInit(idx, screenInfo.screens[idx]);
+    dmxBEScreenInit(screenInfo.screens[idx]);
 
     /* TODO: Handle GLX visual initialization.  GLXProxy needs to be
      * updated to handle dynamic addition/removal of screens. */
@@ -1271,8 +1673,9 @@ int dmxAttachScreen(int idx, DMXScreenAt
     /* Create the scratch GCs */
     dmxBECreateScratchGCs(idx);
 
-    /* Create the default font */
-    (void)dmxBELoadFont(pScreen, defaultFont);
+    /* Create the scratch pixmap */
+    if (pScreen->pScratchPixmap)
+	dmxBECreatePixmap(pScreen->pScratchPixmap);
 
     /* Create all resources that don't depend on windows */
     for (i = currentMaxClients; --i >= 0; )
@@ -1282,6 +1685,7 @@ int dmxAttachScreen(int idx, DMXScreenAt
 
     /* Create window hierarchy (top down) */
     dmxBECreateWindowTree(idx);
+    dmxBECreateWindowProperties(idx);
 
 #ifdef RENDER
     /* Restore the picture state for RENDER */
@@ -1297,25 +1701,13 @@ int dmxAttachScreen(int idx, DMXScreenAt
 				      dmxBERestoreRenderGlyph,(pointer)idx);
 #endif
 
-    /* Refresh screen by generating exposure events for all windows */
-    dmxForceExposures(idx);
-
-    dmxSync(&dmxScreens[idx], TRUE);
+    dmxBEMapRootWindow(idx);
 
-    /* We used these to compare the old and new screens.  They are no
-     * longer needed since we have a newly attached screen, so we can
-     * now free the old screen's resources. */
-    XFree(oldDMXScreen.beVisuals);
-    XFree(oldDMXScreen.beDepths);
-    XFree(oldDMXScreen.bePixmapFormats);
-    /* TODO: should oldDMXScreen.name be freed?? */
-
-#ifdef PANORAMIX
-    if (!noPanoramiXExtension)
-	return dmxConfigureScreenWindows(1, &scrnNum, attr, NULL);
-    else
+#ifdef RANDR
+    RRGetInfo (screenInfo.screens[0]);
 #endif
-	return 0; /* Success */
+
+    dmxInputEnable (&dmxScreen->input);
 }
 
 /*
@@ -1373,6 +1765,7 @@ static void dmxBEFindPixmapImage(pointer
 	int            i;
 
 	pPix = (PixmapPtr)LookupIDByType(pXinPix->info[idx].id, RT_PIXMAP);
+
 	if (pPix != pDst) return; /* Not a match.... Next! */
 
 	for (i = 0; i < PanoramiXNumScreens; i++) {
@@ -1383,6 +1776,7 @@ static void dmxBEFindPixmapImage(pointer
 
 	    pSrc =
 		(PixmapPtr)LookupIDByType(pXinPix->info[i].id, RT_PIXMAP);
+
 	    pSrcPriv = DMX_GET_PIXMAP_PRIV(pSrc);
 	    if (pSrcPriv->pixmap) {
 		FoundPixImage = True;
@@ -1390,6 +1784,87 @@ static void dmxBEFindPixmapImage(pointer
 	    }
 	}
     }
+
+#ifdef RENDER
+    else if ((type & TypeMask) == (XRT_PICTURE & TypeMask))
+    {
+	PixmapPtr     pDst     = (PixmapPtr) p;
+	int           idx      = pDst->drawable.pScreen->myNum;
+	PanoramiXRes  *pXinPic  = (PanoramiXRes *) value;
+	PicturePtr    pPic;
+	int           i;
+
+	pPic = (PicturePtr) LookupIDByType (pXinPic->info[idx].id,
+					    PictureType);
+
+	/* Not a match.... Next! */
+	if (!pPic || !pPic->pDrawable) return;
+	if (pPic->pDrawable->type != DRAWABLE_PIXMAP) return;
+	if (pPic->pDrawable != (DrawablePtr) pDst) return;
+
+	for (i = 0; i < PanoramiXNumScreens; i++) {
+	    dmxPixPrivPtr  pSrcPriv = NULL;
+
+	    if (i == idx) continue; /* Self replication is bad */
+
+	    pPic = (PicturePtr) LookupIDByType (pXinPic->info[i].id,
+						PictureType);
+
+	    pSrcPriv = DMX_GET_PIXMAP_PRIV ((PixmapPtr) pPic->pDrawable);
+	    if (pSrcPriv->pixmap)
+	    {
+		FoundPixImage = True;
+		return;
+	    }
+	}
+    }
+#endif
+
+    else if ((type & TypeMask) == (XRT_WINDOW & TypeMask))
+    {
+	PixmapPtr      pDst     = (PixmapPtr)p;
+	int            idx      = pDst->drawable.pScreen->myNum;
+	PanoramiXRes  *pXinWin  = (PanoramiXRes *) value;
+	Bool	      border;
+	WindowPtr     pWin;
+	int           i;
+
+	pWin = (WindowPtr) LookupIDByType (pXinWin->info[idx].id, RT_WINDOW);
+
+	if (!pWin) return;
+	if (!pWin->borderIsPixel && pWin->border.pixmap == pDst)
+	{
+	    border = TRUE;
+	}
+	else if (pWin->backgroundState == BackgroundPixmap &&
+		 pWin->background.pixmap == pDst)
+	{
+	    border = FALSE;
+	}
+	else
+	{
+	    return;
+	}
+
+	for (i = 0; i < PanoramiXNumScreens; i++) {
+	    dmxPixPrivPtr pSrcPriv = NULL;
+
+	    if (i == idx) continue; /* Self replication is bad */
+
+	    pWin = (WindowPtr) LookupIDByType (pXinWin->info[i].id, RT_WINDOW);
+
+	    if (border)
+		pSrcPriv = DMX_GET_PIXMAP_PRIV (pWin->border.pixmap);
+	    else
+		pSrcPriv = DMX_GET_PIXMAP_PRIV (pWin->background.pixmap);
+
+	    if (pSrcPriv->pixmap)
+	    {
+		FoundPixImage = True;
+		return;
+	    }
+	}
+    }
 }
 #endif
 
@@ -1426,6 +1901,7 @@ static void dmxBESavePixmap(PixmapPtr pP
 	    ScreenPtr      pScreen   = pPixmap->drawable.pScreen;
 	    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
 
+	    XLIB_PROLOGUE (dmxScreen);
 	    pPixPriv->detachedImage = XGetImage(dmxScreen->beDisplay,
 						pPixPriv->pixmap,
 						0, 0,
@@ -1433,8 +1909,15 @@ static void dmxBESavePixmap(PixmapPtr pP
 						pPixmap->drawable.height,
 						-1,
 						ZPixmap);
+	    XLIB_EPILOGUE (dmxScreen);
+
 	    if (!pPixPriv->detachedImage)
-		dmxLog(dmxWarning, "Cannot save pixmap image\n");
+	    {
+		dmxLog(dmxWarning, "Cannot save pixmap image: %p - %dx%d %d\n",
+		       pPixmap, pPixmap->drawable.width,
+		       pPixmap->drawable.height,
+		       pPixmap->drawable.depth);
+	    }
 	}
     }
 #else
@@ -1476,22 +1959,31 @@ static void dmxBEDestroyResources(pointe
     } else if ((type & TypeMask) == (RT_FONT & TypeMask)) {
 	dmxBEFreeFont(pScreen, (FontPtr)value);
     } else if ((type & TypeMask) == (RT_CURSOR & TypeMask)) {
-	dmxBEFreeCursor(pScreen, (CursorPtr)value);
+	dmxBEFreeCursor (pScreen, (CursorPtr) value);
     } else if ((type & TypeMask) == (RT_COLORMAP & TypeMask)) {
 	ColormapPtr  pCmap = value;
 	if (pCmap->pScreen->myNum == scrnNum)
 	    dmxBEFreeColormap((ColormapPtr)value);
+    } else if ((type & TypeMask) == (DMX_SHMSEG & TypeMask)) {
+	dmxBEDetachShmSeg (&dmxScreens[scrnNum], (dmxShmSegInfoPtr) value);
 #ifdef RENDER
     } else if ((type & TypeMask) == (PictureType & TypeMask)) {
 	PicturePtr  pPict = value;
-	if (pPict->pDrawable->pScreen->myNum == scrnNum) {
-	    /* Free the pixmaps on the backend if needed */
-	    if (pPict->pDrawable->type == DRAWABLE_PIXMAP) {
-		PixmapPtr pPixmap = (PixmapPtr)(pPict->pDrawable);
-		dmxBESavePixmap(pPixmap);
-		dmxBEFreePixmap(pPixmap);
+	if (pPict->pDrawable) {
+	    if (pPict->pDrawable->pScreen->myNum == scrnNum) {
+		/* Free the pixmaps on the backend if needed */
+		if (pPict->pDrawable->type == DRAWABLE_PIXMAP) {
+		    PixmapPtr pPixmap = (PixmapPtr)(pPict->pDrawable);
+		    dmxBESavePixmap(pPixmap);
+		    dmxBEFreePixmap(pPixmap);
+		}
+
+		dmxBEFreePicture(pScreen, (PicturePtr)value);
 	    }
-	    dmxBEFreePicture((PicturePtr)value);
+	}
+	else
+	{
+	    dmxBEFreePicture(pScreen, (PicturePtr)value);
 	}
     } else if ((type & TypeMask) == (GlyphSetType & TypeMask)) {
 	dmxBEFreeGlyphSet(pScreen, (GlyphSetPtr)value);
@@ -1531,6 +2023,10 @@ static void dmxBEDestroyWindowTree(int i
 	/* Destroy the window */
 	dmxBEDestroyWindow(pChild);
 
+	if (wUseDefault(pChild, cursor, 0))
+	    dmxBEFreeCursor (screenInfo.screens[idx],
+			     pChild->optional->cursor);
+
 	/* Make sure we destroy the window's border and background
 	 * pixmaps if they exist */
 	if (!pChild->borderIsPixel) {
@@ -1545,6 +2041,9 @@ static void dmxBEDestroyWindowTree(int i
 	while (!pChild->nextSib && (pChild != pWin)) {
 	    pChild = pChild->parent;
 	    dmxBEDestroyWindow(pChild);
+	    if (wUseDefault(pChild, cursor, 0))
+		dmxBEFreeCursor (screenInfo.screens[idx],
+				 pChild->optional->cursor);
 	    if (!pChild->borderIsPixel) {
 		dmxBESavePixmap(pChild->border.pixmap);
 		dmxBEFreePixmap(pChild->border.pixmap);
